<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: InvocationTags.php 3745 2005-10-11 16:44:51Z arlen $
*/

/**
 * @package    MaxPlugins
 * @subpackage DeliveryLimitations
 * @author     Chris Nutting <chris@m3.net>
 */

require_once MAX_PATH . '/lib/max/Plugins/CommonPlugin.php';

/**
 *
 * Plugins_DeliveryLimitations is an abstract class for every Delivery limitation plugin
 *
 */
class Plugins_DeliveryLimitations extends Max_CommonPlugin 
{
    var $ad_id;
    var $logical;
    var $type;
    var $comparison;
    var $data;
    var $executionorder;
    var $count;
    var $res;
    
    /**
     * Initialise this plugin
     *
     * @return void
     */
    function init($data)
    {
        foreach ($data as $name => $value) {
            $this->$name = $value;
        }
        $this->displayName = $this->getName();
        if (is_readable(MAX_PATH . "/plugins/deliveryLimitations/{$this->package}/{$this->name}.res.inc.php")) {
            include MAX_PATH . "/plugins/deliveryLimitations/{$this->package}/{$this->name}.res.inc.php";
            $this->res = $res;
        }
        $this->loadData();
    }
    
    /**
     * Return the name of plugin
     *
     * @return string
     */
    function getName()
    {
        Max::debug('Cannot run abstract method');
        exit();
    }
    
    /**
     * Return if this plugin is available in the current context
     *
     * @return boolean
     */
    function isAllowed($page = false)
    {
        return true;
    }
    
    /**
     * Outputs the HTML to display this limitation
     *
     * @return void
     */
    function display()
    {
        if ($this->executionorder > 0) {
            echo "<tr><td colspan='4'><img src='images/break-el.gif' width='100%' height='1'></td></tr>";
        }
                
        $bgcolor = $this->executionorder % 2 == 0 ? "#E6E6E6" : "#FFFFFF";
        
        echo "<tr height='35' bgcolor='$bgcolor'>";
        echo "<td width='100'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        if ($this->executionorder == 0) {
            echo "<input type='hidden' name='acl[{$this->executionorder}][logical]' value='and'>&nbsp;";
        } else {
            echo "<select name='acl[{$this->executionorder}][logical]' tabindex='".($tabindex++)."'>";
            echo "<option value='or' " . (($this->logical == 'or') ? 'selected' : '') . ">{$GLOBALS['strOR']}</option>";
            echo "<option value='and' " . (($this->logical == 'and') ? 'selected' : '') . ">{$GLOBALS['strAND']}</option>";
            echo "</select>";
        }
        echo "</td><td width='130'>";
		echo "<table cellpadding='2'><tr><td><img src='images/icon-acl.gif' align='absmiddle'>&nbsp;</td><td><strong>{$this->package}</strong>:<br />{$this->displayName}</td></tr></table>";
		echo "<input type='hidden' name='acl[{$this->executionorder}][type]' value='{$this->type}'>";
		echo "<input type='hidden' name='acl[{$this->executionorder}][executionorder]' value='{$this->executionorder}'>";
		echo "</td><td >";
			
        $this->displayComparison();
        
        echo "</td>";
        // Show buttons
		echo "<td align='{$GLOBALS['phpAds_TextAlignRight']}'>";
		echo "<input type='image' name='action[del][{$this->executionorder}]' value='{$this->executionorder}' src='images/icon-recycle.gif' border='0' align='absmiddle' alt='{$GLOBALS['strDelete']}'>";
		echo "&nbsp;&nbsp;";
		echo "<img src='images/break-el.gif' width='1' height='35'>";
		echo "&nbsp;&nbsp;";
		
		if ($this->executionorder && $this->executionorder < $this->count)
			echo "<input type='image' name='action[up][{$this->executionorder}]' src='images/triangle-u.gif' border='0' alt='{$GLOBALS['strUp']}' align='absmiddle'>";
		else
			echo "<img src='images/triangle-u-d.gif' alt='{$GLOBALS['strUp']}' align='absmiddle'>";
		
		if ($this->executionorder < $this->count - 1) {
			echo "<input type='image' name='action[down][{$this->executionorder}]' src='images/triangle-d.gif' border='0' alt='{$GLOBALS['strDown']}' align='absmiddle'>";
		} else {
			echo "<img src='images/triangle-d-d.gif' alt='{$GLOBALS['strDown']}' align='absmiddle'>";
		}
		
		echo "&nbsp;&nbsp;</td></tr>";
		echo "<tr bgcolor='$bgcolor'><td>&nbsp;</td><td>&nbsp;</td><td colspan='2'>";
		
        $this->displayData();
        echo "<br /><br /></td></tr>";
        
        //if (!isset($acl[$key]['type']) || $acl[$key]['type'] != $previous_type && $previous_type != '')
        //echo "<tr><td height='1' colspan='4' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";

    }

    /**
     * Outputs the HTML to display the comparison operator for this limitation
     *
     * @return void
     */
    function displayComparison()
    {
        echo "<select name='acl[{$this->executionorder}][comparison]' tabindex='".($tabindex++)."'>";
		echo "<option value='==' " . (($this->comparison == '==') ? 'selected' : '') . ">{$GLOBALS['strEqualTo']}</option>";
		echo "<option value='!=' " . (($this->comparison == '!=') ? 'selected' : '') . ">{$GLOBALS['strDifferentFrom']}</option>";
		echo "</select>";
    }
    
    /**
     * Outputs the HTML to display the data for this limitation
     *
     * @return void
     */
    function displayData()
    {
    	echo "<input type='text' size='40' name='acl[{$this->executionorder}][data]' value='".phpAds_htmlQuotes(stripslashes(isset($this->data) ? $this->data : ""))."' tabindex='".($tabindex++)."'>";
    }
    
    /**
     * Returns the data for this limitation
     *
     * @return string
     */
    function saveData()
    {
          return $this->data;
    }
    
    /**
     * If $this->data should be an array, this method loads the saved string into an array
     *
     * @return string
     */
    function loadData()
    {
        return true;
    }
    
    /**
     * Returns the compiledlimitation string for this limitation
     *
     * @return string
     */
    function compile()
    {
        $data = addslashes($this->saveData());
        return 'MAX_check' . ucfirst($this->package) . '_' . $this->name . "(\'{$data}\', \'{$this->comparison}\')";
    }
}

?>
